var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import defaultOptions from '../../defaultOptions';
import { extendProps } from '../../Utils/PropsUtils';
import DataRowContent from '../DataRowContent/DataRowContent';
import EmptyCells from '../EmptyCells/EmptyCells';
var DataRow = function (props) {
    var childAttributes = props.childAttributes, dataRow = props.dataRow, groupColumnsCount = props.groupColumnsCount, isSelectedRow = props.isSelectedRow, rowKeyValue = props.rowKeyValue, trRef = props.trRef;
    var dataRowProps = __assign(__assign({}, props), { isSelectedRow: isSelectedRow, rowKeyValue: rowKeyValue });
    var componentProps = {
        className: defaultOptions.css.row + " " + (isSelectedRow ? defaultOptions.css.rowSelected : ''),
    };
    var divProps = extendProps(componentProps, props, childAttributes.dataRow, props.dispatch);
    var dataRowContent = dataRow && dataRow(dataRowProps);
    return (React.createElement("tr", __assign({}, divProps, { ref: trRef }),
        React.createElement(EmptyCells, { count: groupColumnsCount }),
        dataRowContent
            ? React.createElement("td", { className: defaultOptions.css.cell }, dataRowContent)
            : React.createElement(DataRowContent, __assign({}, dataRowProps))));
};
export default DataRow;