import * as React from 'react';
import { updateSortDirection } from '../../actionCreators';
import defaultOptions from '../../defaultOptions';
import { SortDirection, SortingMode } from '../../enums';
var HeadCellContent = function (props) {
    var headCell = props.column.headCell;
    if (headCell) {
        return headCell(props);
    }
    var column = props.column, dispatch = props.dispatch, sortingMode = props.sortingMode;
    var isSortingEnabled = sortingMode === SortingMode.Single;
    var sortClick = isSortingEnabled ? function () {
        dispatch(updateSortDirection(column.key));
    } : undefined;
    return (React.createElement("div", { className: "ka-thead-cell-content " + (isSortingEnabled ? 'ka-pointer' : ''), onClick: sortClick },
        React.createElement("span", null, column.title),
        column.sortDirection && isSortingEnabled && (React.createElement("span", { className: column.sortDirection === SortDirection.Ascend
                ? defaultOptions.css.iconSortArrowUp
                : defaultOptions.css.iconSortArrowDown }))));
};
export default HeadCellContent;