import React, { useEffect, useRef } from 'react';
import { getGroupMark, getGroupText } from '../../Utils/GroupUtils';
import DataRow from '../DataRow/DataRow';
import GroupRow from '../GroupRow/GroupRow';
var Rows = function (props) {
    var columns = props.columns, data = props.data, dispatch = props.dispatch, groupRow = props.groupRow, groupedColumns = props.groupedColumns, _a = props.groups, groups = _a === void 0 ? [] : _a, _b = props.groupsExpanded, groupsExpanded = _b === void 0 ? [] : _b, onFirstRowRendered = props.onFirstRowRendered, rowKeyField = props.rowKeyField, selectedRows = props.selectedRows;
    var groupMark = getGroupMark();
    var firstRowRef = useRef(null);
    useEffect(function () {
        onFirstRowRendered(firstRowRef);
    }, [firstRowRef, onFirstRowRendered]);
    var rowRefLink = firstRowRef;
    return (React.createElement(React.Fragment, null, data.map(function (d) {
        if (d.groupMark === groupMark) {
            var groupIndex = d.key.length - 1;
            var group_1 = groups && groups[groupIndex];
            var column = group_1 && groupedColumns.find(function (c) { return c.key === group_1.columnKey; });
            return (React.createElement(GroupRow, { column: column, contentColSpan: columns.length - groupIndex + groups.length, dispatch: dispatch, groupIndex: groupIndex, groupKey: d.key, groupRow: groupRow, isExpanded: groupsExpanded.some(function (ge) { return JSON.stringify(ge) === JSON.stringify(d.key); }), text: getGroupText(d.value, column), key: d.key }));
        }
        else {
            var rowKeyValue_1 = d[rowKeyField];
            var isSelectedRow = selectedRows.some(function (s) { return s === rowKeyValue_1; });
            var dataRow = (React.createElement(DataRow, { childAttributes: props.childAttributes, columns: props.columns, dataRow: props.dataRow, dispatch: props.dispatch, editableCells: props.editableCells, editingMode: props.editingMode, groupColumnsCount: props.groupColumnsCount, isSelectedRow: isSelectedRow, key: d[rowKeyField], rowData: d, rowKeyField: props.rowKeyField, rowKeyValue: rowKeyValue_1, selectedRows: props.selectedRows, trRef: rowRefLink }));
            rowRefLink = undefined;
            return dataRow;
        }
    })));
};
export default Rows;