var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { isFunction } from 'util';
import { filterData, searchData } from './FilterUtils';
import { getGroupedData } from './GroupUtils';
import { getPageData, getPagesCount } from './PagingUtils';
import { sortData } from './SortUtils';
import { convertToColumnTypes } from './TypeUtils';
export var extendProps = function (childElementAttributes, childProps, childCustomAttributes, dispatch) {
    var resultProps = childElementAttributes;
    if (childCustomAttributes) {
        resultProps = mergeProps(childElementAttributes, childProps, childCustomAttributes, dispatch);
    }
    return resultProps;
};
var emptyFunc = function () { };
export var mergeProps = function (childElementAttributes, childProps, childCustomAttributes, dispatch) {
    var customPropsWithEvents = {};
    var _loop_1 = function (prop) {
        if (childCustomAttributes.hasOwnProperty(prop)) {
            var propName = prop;
            var propValue_1 = childCustomAttributes[propName];
            var baseFunc_1 = childElementAttributes[propName] || emptyFunc;
            if (isFunction(propValue_1)) {
                customPropsWithEvents[prop] = function (e) {
                    propValue_1(e, {
                        baseFunc: baseFunc_1,
                        childElementAttributes: childElementAttributes,
                        childProps: childProps,
                        dispatch: dispatch,
                    });
                };
            }
        }
    };
    for (var prop in childCustomAttributes) {
        _loop_1(prop);
    }
    var mergedResult = __assign(__assign(__assign(__assign({}, childElementAttributes), childCustomAttributes), customPropsWithEvents), {
        className: (childElementAttributes.className || '') + " " + (childCustomAttributes.className || ''),
    });
    return mergedResult;
};
export var prepareTableOptions = function (props) {
    var extendedFilter = props.extendedFilter, groups = props.groups, groupsExpanded = props.groupsExpanded, paging = props.paging, search = props.search;
    var columns = props.columns, _a = props.data, data = _a === void 0 ? [] : _a;
    data = extendedFilter ? extendedFilter(data) : data;
    data = search ? searchData(columns, data, search) : data;
    data = convertToColumnTypes(data, columns);
    data = filterData(data, columns);
    data = sortData(columns, data);
    var groupColumnsCount = 0;
    var groupedColumns = [];
    if (groups) {
        groupColumnsCount = groups.length;
        groupedColumns = columns.filter(function (c) { return groups.some(function (g) { return g.columnKey === c.key; }); });
        columns = columns.filter(function (c) { return !groups.some(function (g) { return g.columnKey === c.key; }); });
    }
    var groupedAllData = groups ? getGroupedData(data, groups, groupedColumns, groupsExpanded) : data;
    var pagesCount = getPagesCount(groupedAllData, paging);
    var groupedData = getPageData(groupedAllData, paging);
    return {
        columns: columns,
        data: data,
        groupColumnsCount: groupColumnsCount,
        groupedColumns: groupedColumns,
        groupedData: groupedData,
        pagesCount: pagesCount
    };
};